﻿using System.Collections.Generic;

namespace Eliza
{
    /// <summary>
    /// The AM pattern.
    /// </summary>
    /// <seealso cref="Eliza.ComplexPattern" />
    class AmPattern : ComplexPattern
    {
        #region Constructor

        /// <summary>
        /// Initializes a new instance of the <see cref="AmPattern"/> class.
        /// </summary>
        public AmPattern()
        {
            // Create the decomp/reassembly rules
            List<DecompReassemblyRule> rules = new List<DecompReassemblyRule>();

            // Rule # 1
            List<string> reassembledResponses = new List<string>();
            reassembledResponses.Add("DO YOU BELIEVE YOU ARE (2)?");
            reassembledResponses.Add("WOULD YOU WANT TO BE (2)?");
            reassembledResponses.Add("DO YOU WISH I WOULD TELL YOU YOU'RE (2)?");
            reassembledResponses.Add("WHAT WOULD IT MEAN IF YOU WERE (2)?");

            // Not in Eliza, but added because they sound realistic
            reassembledResponses.Add("DO YOU THINK YOU'RE (2)?");
            reassembledResponses.Add("HOW WOULD YOU FEEL IF YOU WERE (2)?");
            reassembledResponses.Add("WHAT DO YOU THINK ARE THE CHANCES THAT YOU'RE (2)?");

            // The following responses are from the WHAT pattern
            reassembledResponses.Add("WHY DO YOU ASK?");
            reassembledResponses.Add("DOES THAT QUESTION INTEREST YOU?");
            reassembledResponses.Add("WHAT IS IT YOU REALLY WANTED TO KNOW?");
            reassembledResponses.Add("ARE SUCH QUESTIONS OFTEN ON YOUR MIND?");
            reassembledResponses.Add("WHAT ANSWER WOULD PLEASE YOU MOST?");
            reassembledResponses.Add("WHAT DO YOU THINK?");
            reassembledResponses.Add("WHAT COMES TO MIND WHEN YOU ASK THAT?");
            reassembledResponses.Add("HAVE YOU ASKED SUCH QUESTIONS BEFORE?");
            reassembledResponses.Add("HAVE YOU ASKED ANYONE ELSE?");

            DecompReassemblyRule rule = new DecompReassemblyRule("* AM I *", reassembledResponses);
            rules.Add(rule);

            // Initialize the pattern
            this.Initialize(0, "AM", rules);
        }

        #endregion
    }
}






